
/*
Aspirin SE is a multiplayer game
*/

/*
Take on me
*/

//4245
//(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)
//(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)

#include <tigcclib.h>

/*

*/
#define LINK_MODE_ON TRUE
#define HOST_NO								80 // random
#define JOIN_NO								32 // random

enum asfasdf {JOIN_NUMBER,HOST_NUMBER,QUIT};
void send_and_receive_data(void);
short Wait_2nd_Player(void);

/*

*/
#define DATA_SIZE	(1000)
#define spawnx1 	(1)
#define spawny1 	(1)
#define obst_size (7)
enum menu {goto_play,goto_info,goto_exit,none};


//(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)
//(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)(*)


typedef struct {
	short x;
	short y;
	short delay;
	short score;
	short old_x;
	short old_y;
	short quit;
}STRUCT_PLAYER;

typedef struct {
	short x,y;
	char vx,vy;
}STRUCT_OBSTACLE;
    
typedef struct {
	short x,y;
}STRUCT_GOAL;



short playernum,otherplayernum;
short end_game;
STRUCT_PLAYER p[2];



/*
[...]
*/

void enterr() {
	while (!_keytest (RR_ENTER)){}
	while (_keytest (RR_ENTER)){}
}



/*
Creates 2 random coordinates
*/

void rc(short * x, short * y) {
	*x = random(LCD_WIDTH-14-8)+3+8;
	*y = random(LCD_HEIGHT-9-13-8)+3+8;
}




/*
xor a player.
*/
void xor_player(short x,short y) {
		DrawLine (x,y+1,x,y+2,A_XOR);
		DrawLine (x+1,y,x+1,y+3,A_XOR);
		DrawLine (x+2,y,x+2,y+3,A_XOR);
		DrawLine (x+3,y+1,x+3,y+2,A_XOR);


}

/*
[...]
*/
void sprite_goal(STRUCT_GOAL *goal) {
	int x=goal->x;
	int y=goal->y;    
	DrawLine(x,y,x+6,y,A_XOR);
	DrawLine(x+6,y,x+6,y+6,A_XOR);
	DrawLine(x+6,y+6,x,y+6,A_XOR);
	DrawLine(x,y+6,x,y,A_XOR);
}



/************************************
*
*	Link functions from Travis Fisher
*
*************************************/




/*********************************************************************************************************
*		Sync the calcs
*********************************************************************************************************/


short Wait_2nd_Player(void) {	
	
	FontSetSys(F_4x6);
 	clrscr();
 	printf(
"
Waiting for the other player...
Original Link code by Fisch2
Press [Clear] to cancel and quit");
 	


	
	char Send, Receive = 0, Signal = FALSE, join_no = JOIN_NO;

		// Clear the Link buffer until we empty it or receive the Host Calc's LINK_NO Signal
		while(OSReadLinkBlock(&Receive, 1) == 1) {
			if (Receive == HOST_NO)
				Signal = TRUE;
		}
		if (Signal == TRUE) { // This calc is 2nd to join the game
			Send = join_no;
			OSWriteLinkBlock(&Send, 1);
			playernum=JOIN_NUMBER;
		} else {
			Send = HOST_NO;
			OSWriteLinkBlock(&Send, 1);
			// Tell the Host plr to wait and press Escape to cancel
			playernum=HOST_NUMBER;	
			//g->Calc = Host;
			while(Receive != JOIN_NO) {  // Wait until a signal is received from the Joining Calc
				OSReadLinkBlock(&Receive, 1);
				if (Receive == HOST_NO) {
				// This calc entered Multiplayer before the other calc had even started the game.  Thus, this 
				// calc's original HOST_NO message to the other calc was disregarded by the other calc's AMS.
					OSLinkOpen();
					Send = JOIN_NO;
					OSWriteLinkBlock(&Send, 1);
					playernum=JOIN_NUMBER;
					break;
				} 
				if (_keytest(RR_CLEAR)) {
					Signal = QUIT;
			    OSWriteLinkBlock(&Signal, 1);
					return(FALSE);
				}
			}
	}
	return(TRUE);  // Connection successfully established
}




/*********************************************************************************************************
*		Routine that sends and receives the data at each frame (when playing in multiplayer).
*********************************************************************************************************/
void send_and_receive_data() {
	
	unsigned char data_send=0;
	data_send =		((p[playernum].old_x<p[playernum].x)) |
								((p[playernum].old_x>p[playernum].x)<<1) |
								((p[playernum].old_y<p[playernum].y)<<2) |
								((p[playernum].old_y>p[playernum].y)<<3) |
								(p[playernum].quit*0b11111111);
//	if (p[playernum].quit)
//	data_send = 0b11111111;
	
	unsigned char data_received=0;
	
	if (playernum == HOST_NUMBER) {
		LIO_RecvData(&data_received, 1, 0);
		LIO_SendData (&data_send, 1);
	} else {
		LIO_SendData (&data_send, 1);
		LIO_RecvData(&data_received, 1, 0);
	}

	//data_received = 1;
	//char st[10];
	//sprintf(st,"%i%i%i%i",(data_received&0b1000)!=0,(data_received&0b100)!=0,(data_received&0b10)!=0,(data_received&0b1)!=0);
//sprintf(st,"%i%i%i%i",(data_send&0b1000)!=0,(data_send&0b100)!=0,(data_send&0b10)!=0,(data_send&0b1)!=0);
		
	
	//DrawStr(0,0,st,A_REPLACE);
	p[!playernum].x		= p[!playernum].x + (data_received&0b1) - ((data_received&0b10)!=0);
	p[!playernum].y		= p[!playernum].y + ((data_received&0b100)!=0) - ((data_received&0b1000)!=0);
	p[!playernum].quit = data_received == 0b11111111;
	
}


/*********************************************************************************************************
*		Draws the score (at the bottom of the screen)
*********************************************************************************************************/

char * com[] = {(char*)&"You are winning",(char*)&"You are loosing",(char*)&"Draw"};
void refresh_scores() {
	char s[50];//I am in no mood to count :/A
	memset(LCD_MEM+92*30,0,30*9);
	sprintf(s,"You:%i  Him:%i   ...   %s !",p[playernum].score,p[!playernum].score,com[  (p[playernum].score<=p[!playernum].score)  +  (p[playernum].score==p[!playernum].score)   ]);
	FontSetSys(F_4x6);
	DrawStr(2,93,s,A_NORMAL);
}





void init_obstacle(STRUCT_OBSTACLE * o) {
	
	do {
		rc(&(o->x),&(o->y));
	} while (abs((o->x)-(signed short)p[0].x) < 7 || abs(o->y-(signed short)p[0].y) < 7 || abs(o->x-(signed short)p[1].x) < 7 || abs(o->y-(signed short)p[1].y) < 7);
		
  int r = random(2);
	o->vx = r;
	o->vy = abs(r-1);
	
	DrawLine(o->x+(o->vx),o->y+(o->vy),o->x+7*abs(o->vx),o->y+7*abs(o->vy),A_XOR);

}



/*
|\/|4||\|  |=|_||\|(7|0|\|
*/
static char list[]={0|(1<<2),
										0|(2<<2),
										1|(0<<2),
										1|(3<<2),
										2|(0<<2),
										2|(3<<2),
										3|(1<<2),
										3|(2<<2)};

static short s_x[2] = {20,60};
static short s_y[2] = {20,60};

void _main() {
	
	int loop;
	int result;


	int quit=0;
	int loss=0;
	int max=3;
	STRUCT_OBSTACLE *obst;

	obst = malloc( sizeof(STRUCT_OBSTACLE)*DATA_SIZE);
	if (!obst)
	exit(0);
	
	INT_HANDLER save_int_1;
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	INT_HANDLER save_int_5;
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_5, DUMMY_HANDLER);



	do {
		result = none;

		memset(LCD_MEM,0,LCD_SIZE);
		
		FontSetSys(F_8x10);
		DrawStr (2,14,"Multiplayer Aspirin",A_NORMAL);
		
		FontSetSys(F_6x8);
		DrawStr (20,44,"[1]:Play   [2]:Exit",A_NORMAL);
		
		FontSetSys(F_4x6);
		DrawStr (70,70,"by JfG",A_NORMAL);
		DrawStr (30,78,"http://www.tigen.org/jyaif",A_NORMAL);		
		DrawStr (40,78+8,"jfgeyelin@gmail.com",A_NORMAL);			
		DrawStr (140,25,"v0.9",A_NORMAL);			

		while (result == none) {
			if (_keytest(RR_1))
			result = goto_play;
			if (_keytest(RR_2))
			result = goto_exit;
		}		



		if (result == goto_play) {
			
			if (!Wait_2nd_Player())
			goto MENU;



			
			randomize();
			short stroumpf = random(1000);
			if (playernum==0) {
			LIO_SendData ((char*)&(stroumpf),sizeof(short));			
			} else {
			LIO_RecvData(&(stroumpf), sizeof(short),0);
			}
			srand(stroumpf);
			
			
			int i;

			ClrScr();
			DrawLine(0,0,159,0,A_NORMAL);
			DrawLine(159,0,159,91,A_NORMAL);
			DrawLine(159,91,0,91,A_NORMAL);
			DrawLine(0,0,0,91,A_NORMAL);

			STRUCT_GOAL goal;
			goal.x = 10;
			goal.y = 10;
			
			for (i=2;i--;) {
				p[i].x = s_x[i];
				p[i].y = s_y[i];
				p[i].delay = 0;
				p[i].score = 0;
				p[i].quit = FALSE;
			}
			
			
			for (i=max-1;i--;)
			init_obstacle(&(obst[i]));


			//FontSetSys(F_8x10);			

			sprite_goal(&goal);
		  xor_player(p[0].x,p[0].y);
		  xor_player(p[1].x,p[1].y);
	  	refresh_scores();

			quit = FALSE;

			
			
			while (!quit) {
				p[playernum].delay -= p[playernum].delay !=0;
				
				p[0].old_x = p[0].x;
				p[0].old_y = p[0].y;
				p[1].old_x = p[1].x;
				p[1].old_y = p[1].y;			
				
				
				
				if (p[playernum].delay == 0) {
					if (_keytest(RR_LEFT))
				  p[playernum].x--;
				  if (_keytest(RR_RIGHT))
				  p[playernum].x++;
				  if (_keytest(RR_UP))
				  p[playernum].y--;
				  if (_keytest(RR_DOWN))
				  p[playernum].y++;

			  }
			  if (_keytest(RR_ESC))
			  p[playernum].quit = TRUE;			  
			  
			 	send_and_receive_data();
			  
				

				xor_player(p[0].old_x,p[0].old_y);
				xor_player(p[1].old_x,p[1].old_y);
				
				
				//Detect loss with the latest coord of the player.
				for (i=2;i--;) {
					loss=0;
					for (loop=8;loop--;) {
						loss+=GetPix(p[i].x+(list[loop]&0b00000011),p[i].y+(list[loop]>>2));
					}
					if (0!=loss) {
						p[i].x = s_x[i];
						p[i].y = s_y[i];
						p[i].delay = 20;
					}
				}
				loss=0;
			  
			  xor_player(p[0].x,p[0].y);
			  xor_player(p[1].x,p[1].y);	
			  
				
				quit = p[0].quit | p[1].quit;
			

				
				//Check if the player caught the goal.
				for (i=2;i--;) {
				if (abs(goal.x-p[i].x+1) < 7 && abs(goal.y+1-p[i].y) <7) {
					p[i].score++;
					refresh_scores();
					sprite_goal(&goal);
					
					rc(&goal.x,&goal.y);

					sprite_goal(&goal);


				
					
					for (loop=3;loop--;) {//3 obstacles are added
					  init_obstacle(&obst[max-1]);
						max++;
					}
				}
			}
				
				
				
				
				//Move all the obstacles; it XORs a pixel at the beginnig and at the end of each segments.
			
				for (loop = max-1; loop --;) {
					obst[loop].x += obst[loop].vx;
			    obst[loop].y += obst[loop].vy;			    
			   
			    DrawPix(obst[loop].x,obst[loop].y,A_XOR);
					DrawPix(obst[loop].x+7*abs(obst[loop].vx),obst[loop].y+7*abs(obst[loop].vy),A_XOR);
			    if (obst[loop].x<=1 || obst[loop].x>=LCD_WIDTH-8) {
			        obst[loop].vx = -obst[loop].vx;
			 			  DrawPix(obst[loop].x,obst[loop].y,A_XOR);
							DrawPix(obst[loop].x+7*abs(obst[loop].vx),obst[loop].y+5*abs(obst[loop].vy),A_XOR);
			        }
			    if (obst[loop].y<=1 || obst[loop].y>=LCD_HEIGHT-9-8) {
			        obst[loop].vy = -obst[loop].vy;
			   		  DrawPix(obst[loop].x,obst[loop].y,A_XOR);
							DrawPix(obst[loop].x+7*abs(obst[loop].vx),obst[loop].y+7*abs(obst[loop].vy),A_XOR);
			    }  
				}	/**/


			}

			//pokeIO(0x600017,(HW_VERSION==1?0xB2:0xCC));
		}
		MENU:
	} while (result != goto_exit);// && !quit);
	
	
	while (_keytest(RR_2)) {};
	
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5 , save_int_5);

  
  free(obst);
  

}

